﻿@page "/login"
@layout LoginLayout
@inject NavigationManager NavigationManager
@inject HttpClient _httpClient
@inject IJSRuntime _jsRuntime
@inject ILogger<Login> Logger
@inject AuthenticationStateProvider AuthStateProvider

<MudGrid Justify="Justify.Center">
    <MudItem xs="12" sm="8" md="6" lg="4" xl="3">
        <MudPaper Elevation="8" Class="pa-4">
            <MudTabs>
                <MudTabPanel Text="Sign In">
                    @* <MudText Typo="Typo.h5" Class="pt-3 pb-1.5" GutterBottom="true">Sign In</MudText> *@
                    <MudForm @ref="form" @bind-IsValid="isValid">
                        <MudTextField Label="Username" Variant="Variant.Filled" @bind-Value="loginModel.Username" Required="true" RequiredError="Username is required!" FullWidth />
                        <MudTextField Label="Password" Variant="Variant.Filled" @bind-Value="loginModel.Password" Required="true" RequiredError="Password is required!" InputType="InputType.Password" FullWidth />
                        <MudButton Variant="Variant.Filled" Color="Color.Primary" Class="mt-4" OnClick="HandleLogin">Log in</MudButton>
                    </MudForm>
                    @if (loginFailed)
                    {
                        <MudAlert Severity="Severity.Error" Class="mt-4">@errorMessage</MudAlert>
                    }
                </MudTabPanel>
            </MudTabs>
        </MudPaper>
    </MudItem>
</MudGrid>

@code {
    private MudForm form;
    private MudForm registerForm;
    private PostAuthenticationRequestModel loginModel = new PostAuthenticationRequestModel();
    private PostUserModel registerModel = new PostUserModel();
    private bool loginFailed;
    private bool registerFailed;
    private bool isValid;
    private bool isRegisterValid;
    private string errorMessage = "Login failed, please try again.";
    private string registerErrorMessage = "Registration failed, please try again.";

    private async Task HandleLogin()
    {
        loginFailed = false;
        await form.Validate();

        if (isValid)
        {
            var success = await LoginAsync(loginModel);
            if (success)
            {
                NavigationManager.NavigateTo("/");
            }
            else
            {
                loginFailed = true;
                errorMessage = "Wrong credentials, please check and try again.";
            }
        }
    }

    private async Task HandleRegister()
    {
        registerFailed = false;
        await registerForm.Validate();

        if (isRegisterValid)
        {
            var success = await RegisterAsync(registerModel);
            if (success)
            {
                NavigationManager.NavigateTo("/login");
            }
            else
            {
                registerFailed = true;
                registerErrorMessage = "Registration failed, please try again.";
            }
        }
    }

    public async Task<bool> LoginAsync(PostAuthenticationRequestModel loginModel)
    {
        var response = await _httpClient.PostAsJsonAsync("/api/Users/Authenticate", loginModel);
        if (response.IsSuccessStatusCode)
        {
            var authResponse = await response.Content.ReadFromJsonAsync<PostAuthenticationResponseModel>();
            await ((CustomAuthenticationStateProvider)AuthStateProvider).MarkUserAsAuthenticated(authResponse);
            return true;
        }
        else
        {
            var responseContent = await response.Content.ReadAsStringAsync();
            Logger.LogError("Login failed with HTTP status {Status}: {Content}", response.StatusCode, responseContent);
            return false;
        }
    }

    public async Task<bool> RegisterAsync(PostUserModel registerModel)
    {
        var response = await _httpClient.PostAsJsonAsync("/api/Users", registerModel);
        if (response.IsSuccessStatusCode)
        {
            return true;
        }
        else
        {
            var responseContent = await response.Content.ReadAsStringAsync();
            Logger.LogError("Registration failed with HTTP status {Status}: {Content}", response.StatusCode, responseContent);
            return false;
        }
    }
}
